library ieee;

use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_signed.all;
entity alu is
	port( clk,en: in std_logic;
	A,B: in std_logic_vector(15 downto 0);
	op: in std_logic_vector( 1 downto 0);
	R: out std_logic_vector(15 downto 0);
	ready: out std_logic );
end alu;

architecture beh of alu is
type stati is (idle, decode, shift,somma,mult, fine);
signal S : stati;
signal conta: integer range 0 to 3;
signal shift_en,somma_en,mult_en,fine_en: std_logic;

begin
	process(clk)
	begin
		if clk'event and clk='0' then
			if en = '0' then S <= idle;
			else case S is
				when idle => if en= '1' then 
					           S<= decode;
				             else S<= idle;
							 end if;
			   when decode => case op is 
				                when "00" => S<= somma;
				   				when "01"|"10"  => S<= shift;
								when "11"  => S<= mult;
								when others => S<= idle;
			                 end case;
			  when shift => S<= fine;
			  when somma => if conta <1 then 
				               S<= somma;
			                else S<= fine;
				  			end if;
			 when mult => if conta=2 then S<= fine;
			              else S<= mult;
				 		  end if;
			when others => S<= idle;
		 end case;
	   end if;
	end if;
   end process;
   
   process(S)
   begin
	 if S= shift then shift_en<= '1';
	 else shift_en<= '0';
     end if;
	 if S=somma  then somma_en<= '1';
	 else somma_en<= '0';
	 end if;
	 if S=mult then mult_en<= '1';
	 else mult_en<= '0';
     end if;
	 if S=fine then fine_en<= '1';
	 else fine_en<= '0';
     end if;
   end process;
   
   process(clk)
   begin
	   if clk'event and clk='0' then
		   if en='0' then conta <= 0;
		   end if;
		   if somma_en= '1' then
			   if conta < 1 then conta <= conta +1;
			   else R<= A+B;
			   end if;
	      end if;
		  if shift_en= '1' then 
			  if op = "01" then 
				  R<= SHR(A,B);
			  else R<= SHL(A,B);
			  end if;
		end if;
		if mult_en= '1' then
			if conta<2 then
				conta <= conta +1;
			else R<= conv_std_logic_vector(conv_integer(A(7 downto 0))*conv_integer(B(7 downto 0)),16);
			end if;
		end if;
		
		  
	  end if;
	end process;
	
	ready <= fine_en;
		 
 end beh;
 
 
	   